#include "internet_radio.h"
#include "addstation.h"

Internet_Radio::Internet_Radio(QWidget *parent)
    : QMainWindow(parent)
{
	ui.setupUi(this);

	setStationModel(createStationModel(this));

	connect(ui.pushButton_GO, SIGNAL(clicked()), this, SLOT(GO_clicked()));
	connect(ui.pushButton_ADD, SIGNAL(clicked()), this, SLOT(ADD_clicked()));
	connect(ui.pushButton_REMOVE, SIGNAL(clicked()), this, SLOT(REMOVE_clicked()));
	connect(ui.pushButton_PLAY, SIGNAL(clicked()), this, SLOT(PLAY_clicked()));
//    ui.tableView->setRootIsDecorated(false);
    ui.tableView->setAlternatingRowColors(true);
    ui.tableView->horizontalHeader()->setDefaultSectionSize(250);
    ui.tableView->horizontalHeader()->resizeSection(0, 200);
    ui.tableView->horizontalHeader()->resizeSection(1, 300);
}

Internet_Radio::~Internet_Radio()
{

}

void Internet_Radio::addStation(QAbstractItemModel *model, const QString &station,
             const QString &url)
{
    model->insertRow(0);
    model->setData(model->index(0, 0), station);
    model->setData(model->index(0, 1), url);
}

QAbstractItemModel* Internet_Radio::createStationModel(QObject *parent)
{
	model = new QStandardItemModel(0, 2, parent);

    model->setHeaderData(0, Qt::Horizontal, QObject::tr("Station"));
    model->setHeaderData(1, Qt::Horizontal, QObject::tr("URL"));

    addStation(model, "Absolute Classic Rock - non stop classic rock from the makers of Absolute Radio UK", "http://ogg2.as34763.net/vc32.ogg");
    addStation(model, "Radically new concept", "URL-Bla2");

    return model;
}
void Internet_Radio::GO_clicked()
{
	QUrl currentURL;
	currentURL = ui.lineEdit_ADDRESS->text();
	ui.webView->load(currentURL);
}

void Internet_Radio::ADD_clicked()
{
	AddStation* newStation = new AddStation();
	newStation->exec();

	if(!(newStation->sName.isEmpty()) & !(newStation->url.isEmpty()))
	{
		addStation(model, newStation->sName, newStation->url);
	}
}

void Internet_Radio::REMOVE_clicked()
{
	QModelIndex mindex = ui.tableView->currentIndex();
	mindex.row();
	model->removeRow(mindex.row());
}

void Internet_Radio::PLAY_clicked()
{

}

void Internet_Radio::setStationModel(QAbstractItemModel *model)
{
    ui.tableView->setModel(model);
}
